package jalview.ws.slivkaws;

import jalview.ws.params.ArgumentI;
import jalview.ws.params.ParamDatastoreI;
import jalview.ws.params.WsParamSetI;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import uk.ac.dundee.compbio.slivkaclient.SlivkaService;

public class SlivkaDatastore implements ParamDatastoreI
{
  private SlivkaParamSet defaultPreset;
  private List<WsParamSetI> presets = new ArrayList<>();

  SlivkaDatastore(SlivkaService service) throws IOException {
    defaultPreset = new SlivkaParamSet(service);
  }

  @Override
  public List<WsParamSetI> getPresets()
  {
    return presets;
  }

  @Override
  public WsParamSetI getPreset(String name)
  {
    for (WsParamSetI preset : presets)
    {
      if (preset.getName().equals(name))
      {
        return preset;
      }
    }
    return null;
  }

  @Override
  public List<ArgumentI> getServiceParameters()
  {
    return new ArrayList<>(defaultPreset.getArguments());
  }

  @Override
  public boolean presetExists(String name)
  {
    for (WsParamSetI preset : presets)
    {
      if (preset.getName().equals(name))
      {
        return true;
      }
    }
    return false;
  }

  @Override
  public void deletePreset(String name)
  {
  }

  @Override
  public void storePreset(String presetName, String text, List<ArgumentI> jobParams)
  {
  }

  @Override
  public void updatePreset(String oldName, String presetName, String text, List<ArgumentI> jobParams)
  {
  }

  @Override
  public WsParamSetI parseServiceParameterFile(String name, String description, String[] serviceURL, String parameters)
      throws IOException
  {
    return null;
  }

  @Override
  public String generateServiceParameterFile(WsParamSetI pset) throws IOException
  {
    return null;
  }

}
